Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- File List
- File Members

eax.h
Go to the documentation of this file.
1 /*
2 * EAX Mode
3 * (C) 1999-2007,2013 Jack Lloyd
4 * (C) 2016 Daniel Neus, Rohde & Schwarz Cybersecurity
5 *
6 * Botan is released under the Simplified BSD License (see license.txt)
7 */
8
9 #ifndef BOTAN_AEAD_EAX_H__
10 #define BOTAN_AEAD_EAX_H__
11
12 #include <botan/aead.h>
13 #include <botan/block_cipher.h>
14 #include <botan/stream_cipher.h>
15 #include <botan/mac.h>
16
17 namespace Botan {
18
19 /**
20 * EAX base class
21 */
22 class BOTAN_DLL EAX_Mode : public AEAD_Mode
23 {
24 public:
25 void set_associated_data(const uint8_t ad[], size_t ad_len) override;
26
27 std::string name() const override;
28
29 size_t update_granularity() const override;
30
31 Key_Length_Specification key_spec() const override;
32
33 // EAX supports arbitrary nonce lengths
34 bool valid_nonce_length(size_t) const override { return true; }
35
36 size_t tag_size() const override { return m_tag_size; }
37
38 void clear() override;
39
40 void reset() override;
41
42 protected:
43 /**
44 * @param cipher the cipher to use
45 * @param tag_size is how big the auth tag will be
46 */
47 EAX_Mode(BlockCipher* cipher, size_t tag_size);
48
49 size_t block_size() const { return m_cipher->block_size(); }
50
51 size_t m_tag_size;
52
53 std::unique_ptr<BlockCipher> m_cipher;
54 std::unique_ptr<StreamCipher> m_ctr;
55 std::unique_ptr<MessageAuthenticationCode> m_cmac;
56
57 secure_vector<uint8_t> m_ad_mac;
58
59 secure_vector<uint8_t> m_nonce_mac;
60 private:
61 void start_msg(const uint8_t nonce[], size_t nonce_len) override;
62
63 void key_schedule(const uint8_t key[], size_t length) override;
64 };
65
66 /**
67 * EAX Encryption
68 */
69 class BOTAN_DLL EAX_Encryption final : public EAX_Mode
70 {
71 public:
72 /**
73 * @param cipher a 128-bit block cipher
74 * @param tag_size is how big the auth tag will be
75 */
76 EAX_Encryption(BlockCipher* cipher, size_t tag_size = 0) :
77 EAX_Mode(cipher, tag_size) {}
78
79 size_t output_length(size_t input_length) const override
80 { return input_length + tag_size(); }
81
82 size_t minimum_final_size() const override { return 0; }
83
84 size_t process(uint8_t buf[], size_t size) override;
85
86 void finish(secure_vector<uint8_t>& final_block, size_t offset = 0) override;
87 };
88
89 /**
90 * EAX Decryption
91 */
92 class BOTAN_DLL EAX_Decryption final : public EAX_Mode
93 {
94 public:
95 /**
96 * @param cipher a 128-bit block cipher
97 * @param tag_size is how big the auth tag will be
98 */
99 EAX_Decryption(BlockCipher* cipher, size_t tag_size = 0) :
100 EAX_Mode(cipher, tag_size) {}
101
102 size_t output_length(size_t input_length) const override
103 {
104 BOTAN_ASSERT(input_length >= tag_size(), "Sufficient input");
105 return input_length - tag_size();
106 }
107
108 size_t minimum_final_size() const override { return tag_size(); }
109
110 size_t process(uint8_t buf[], size_t size) override;
111
112 void finish(secure_vector<uint8_t>& final_block, size_t offset = 0) override;
113 };
114
115 }
116
117 #endif
Botan::EAX_Decryption::EAX_Decryption
EAX_Decryption(BlockCipher *cipher, size_t tag_size=0)
Definition: eax.h:99
Botan::EAX_Decryption::output_length
size_t output_length(size_t input_length) const override
Definition: eax.h:102
Botan::Key_Length_Specification
Definition: key_spec.h:18
Botan::EAX_Mode
Definition: eax.h:22
Botan::EAX_Mode::m_ad_mac
secure_vector< uint8_t > m_ad_mac
Definition: eax.h:57
Botan::EAX_Mode::m_nonce_mac
secure_vector< uint8_t > m_nonce_mac
Definition: eax.h:59
Botan::EAX_Encryption::EAX_Encryption
EAX_Encryption(BlockCipher *cipher, size_t tag_size=0)
Definition: eax.h:76
Botan::EAX_Decryption
Definition: eax.h:92
Botan::EAX_Encryption
Definition: eax.h:69
Botan::EAX_Mode::m_tag_size
size_t m_tag_size
Definition: eax.h:51
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27
Botan::secure_vector
std::vector< T, secure_allocator< T >> secure_vector
Definition: secmem.h:121
Botan::EAX_Encryption::output_length
size_t output_length(size_t input_length) const override
Definition: eax.h:79
Botan::EAX_Mode::valid_nonce_length
bool valid_nonce_length(size_t) const override
Definition: eax.h:34
Botan
Definition: alg_id.cpp:13
Botan::EAX_Mode::block_size
size_t block_size() const
Definition: eax.h:49
Botan::EAX_Mode::m_cipher
std::unique_ptr< BlockCipher > m_cipher
Definition: eax.h:53
Botan::EAX_Encryption::minimum_final_size
size_t minimum_final_size() const override
Definition: eax.h:82
Botan::AEAD_Mode
Definition: aead.h:22
Botan::EAX_Mode::tag_size
size_t tag_size() const override
Definition: eax.h:36
Botan::EAX_Mode::m_cmac
std::unique_ptr< MessageAuthenticationCode > m_cmac
Definition: eax.h:55
Botan::EAX_Mode::m_ctr
std::unique_ptr< StreamCipher > m_ctr
Definition: eax.h:54
Botan::EAX_Decryption::minimum_final_size
size_t minimum_final_size() const override
Definition: eax.h:108
Botan::BlockCipher
Definition: block_cipher.h:19